#ifndef DCANVAS_PROXY_CLIENT_H
#define DCANVAS_PROXY_CLIENT_H

#include <utl/client.h>
#include <ds/array.h>
#include <vgl/corba/defines.h>
#include <vgl/defines.h>
#include <stdio.h>

class VglCanvas;
class VglCORBANotifier;

class VglDCanvasProxyClient
{
  VglCanvas *m_canvas;
  UtlClient m_client;
  VglCORBANotifier *m_notifier;
  int m_compression_level;
  DsArray<char*> m_initparameters;
  DsArray<unsigned char> m_buffer;
  DsArray<unsigned char> m_compbuffer;
  VglFunction m_redrawfunc;
  void *m_redrawdata;
  VglReshapeFunction m_reshapefunc;
  void *m_reshapedata;
  int m_lastwidth, m_lastheight;
  bool m_connected;
  static void RedrawFunc (void *);
  static void ReshapeFunc (int w, int h, void *);
  DsArray<unsigned char>* Decompress ();
  void Redraw ();
  void Reshape (int w, int h);
  bool ReceiveString (char *buffer, size_t buffersize);
  bool SendString (char *buffer);
public:
  VglDCanvasProxyClient ();
  ~VglDCanvasProxyClient ();
  void SetCompressionLevel (int level)
  {
    m_compression_level = level;
  }
  void AddInitParameter (const char *parameter);
  void Attach (VglCanvas *canvas);
  bool Detach (VglCanvas *canvas);
  bool Connect (const char *address, int port);
  void Terminate ();
};

#endif
