//* dcanvassortfirst.h
// fabraham@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// Jan 2004

#ifndef VGL_DCANVASSORTFIRST_H
#define VGL_DCANVASSORTFIRST_H

#include <vgl/dvgl/defines.h>
#include <ds/array.h>
#include <ds/queue.h>
#include <ds/pool.h>
#include <pthread.h>
#include "dcanvastiled.h"

//class VglBufferManager2;

class VGL_API VglDCanvasSortFirst : public VglDCanvasTiled
{
public:
  class SortFirstTile : public VglDCanvas::Tile
  {
  };
  class SortFirstFrame : public VglDCanvasTiled::TiledFrame
  {
  };
private:
//  VglBufferManager2 *m_bufman;
  typedef struct
  {
    int totalbuffersize;
    double time;
    double loadimbal;
    double rendertime;
    int latency;
    double latencytime;
    double nettime;
    int primcount;
  } FrameInfo;
  bool m_showlines;
  bool m_showfps;
  float m_linecolor[3];
  // fps control
  double m_fps, m_t0, m_net_t, m_avgnet, m_lat, m_avglat, m_avgbytes, m_decomp_t, m_avgdecomp, m_write_t, m_avgwrite;
  unsigned long m_bytes;
  double m_avgimbal, m_imbal_acc;
  double m_last_compl_t;
  DsArray<FrameInfo> m_framehistory;
  double m_firstframetime;
  int m_currframe;
//  bool m_usebuffer;
private:
  // sets up the buffer manager
//  void SetupFrameBuffers (SortFirstFrame* frame, int numtiles);
protected:
  virtual void PackTiles (Frame* frame, DsArray<unsigned char>* userparams);
public:
  virtual Tile* AllocTile ()
  {
    return new SortFirstTile();
  }
  virtual Frame* AllocFrame ()
  {
    return new SortFirstFrame();
  }
public:
  VglDCanvasSortFirst (VglCanvas* canvas);
  virtual ~VglDCanvasSortFirst ();

  void SetShowFPS (bool flag)
  {
    m_showfps = flag;
  }
  bool GetShowFPS ()
  {
    return m_showfps;
  }
  void SetShowLines (bool flag)
  {
    m_showlines = flag;
  }
  void SetLineColor (float r, float g, float b)
  {
    m_linecolor[0] = r;
    m_linecolor[1] = g;
    m_linecolor[2] = b;
  }
  bool GetShowLines ()
  {
    return m_showlines;
  }
  double GetFPS ()
  {
    return m_fps;
  }
  double GetLatency ()
  {
    return m_avglat;
  }
  double GetNetTime ()
  {
    return m_avgnet;
  }
  double GetAvgTransferredBytes ()
  {
    return m_avgbytes;
  }
  double GetDecompressionTime ()
  {
    return m_avgdecomp;
  }
  double GetAvgLoadImbalance ()
  {
    return m_avgimbal;
  }
  double GetWriteTime ()
  {
    return m_avgwrite;
  }
/*
  bool GetUseBuffer ()
  {
    return m_usebuffer;
  }
  void SetUseBuffer (bool f)
  {
    m_usebuffer = f;
  }
*/
  bool SaveFrameTimeHistory (char* localfilename, char* clusterfilename);
  // virtual methods
  virtual void Redraw ();
};

#endif

