//* 3dselection.h
// fabraham@tecgraf.puc-rio.br
// sam@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// Aug 2003

#ifndef VGL_3DSELECTION_H
#define VGL_3DSELECTION_H

#include "selection.h"
#include <vgl/defines.h>
#include <vgl/manipulatable.h>

class AlgVector;
class VglViewSurface;

class VGL_API Vgl3DSelectionHandler : public VglSelectionHandler
{
  typedef struct
  {
    VglManipulatable* manip;
    unsigned int name;
  } Manip;
  typedef DsPList<Manip> ManipList;
  ManipList m_manip_list;
  void  (*m_process_func)(VglManipulatable*,void*);
  void* m_process_func_data;
  float m_last_x, m_last_y;
  VglCanvas* m_canvas;
public:
  static char* CLASSNAME () { return "SelectionHandler"; }
  virtual char* ClassName ()  { return CLASSNAME(); }
  Vgl3DSelectionHandler (VglCanvas* canvas, int sel_buf_size=512, double tolw=5.0, double tolh=5.0);
  virtual ~Vgl3DSelectionHandler ();
  void SetProcessFunc(void (*process_func)(VglManipulatable*, void* data), void* data);
  void SetProcessFunc(void (*process_func)(SelHitList* list, void* data), void* data);
  void CallProcessFunc(VglManipulatable* manip, float zmin);
  unsigned int Register(VglManipulatable* manip);
  VglManipulatable* GetManipulatable (unsigned int name);
  virtual void Trace(
    AlgVector & position, 
    AlgVector & direction,
    float tolx=0.01, 
    float toly=0.01, 
    float range=1000.0
    );
  virtual void Pick(float x, float y, double tolw=5.0, double tolh=5.0);
  virtual void GetVisible();
  virtual int MouseButton (int bt, int st, float x, float y);
};

#endif
