//* imagewriter.h
// fabraham@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// June 2004

#ifndef VGL_IMAGEWRITER_H
#define VGL_IMAGEWRITER_H

#include <vgl/handler.h>
#include <ds/array.h>

class VglCanvas;

class VGL_API VglImageWriter : public VglHandler
{
  VglCanvas* m_canvas;
  int m_frameindex;
  char* m_basefilename;
  char* m_extension;
  char* m_compression;
  bool m_paused;
  DsArray<unsigned char*> m_buffer;
public:
  static char* CLASSNAME () { return "ImageWriter"; }
  virtual char* ClassName () const { return CLASSNAME(); }

  VglImageWriter (VglCanvas* canvas);
  virtual ~VglImageWriter ();
  
  void SetBaseFileName (char* filename);
  void SetImagesExtension (char* extension);
  void SetImagesCompression (char* compression);

  void Pause ()
  {
    m_paused = !m_paused;
  }
  
  virtual int PostRedraw ();
};

#endif
