//* manip.h
// celes@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// Jan 2003

#ifndef VGL_MANIP_H
#define VGL_MANIP_H

#include <vgl/handler.h>

class VglViewSurface;
class AlgVector;

class VGL_API VglManipHandler : public VglHandler
{
  char m_constraint;
  int  m_feedback;
  const AlgVector* m_box;
  VglViewSurface* m_surface;
  AlgVector* m_rot_yaxis;
	bool m_moving;
  bool m_animated;

  static void RepeatTransform (void* data);
public:
  /**
   * Returns the event handler class classname.
   * \return Event handler class classname.
   */
  static char* CLASSNAME () { return "ManipHandler"; }
  virtual char* ClassName () const { return CLASSNAME(); }

  VglManipHandler (VglViewSurface* surface);
  virtual ~VglManipHandler ();
  void SetFeedback (int mode);
  int GetFeedbackMode ()
  {
    return m_feedback;
  }
  void SetViewBox (const AlgVector* box);
  void SetAnimated (bool animated)
  {
    m_animated = animated;
  }
  void SetYRotationAxis (AlgVector& axis);
  void SetYRotationAxis (float vx, float vy, float vz);
  void UnsetYRotationAxis ();
  AlgVector* GetYRotationAxis ()
  {
    return m_rot_yaxis;
  }
	/**
	 * Returns true in case the model/scene is moving because of this manipulator, false otherwise.
	 */
	bool IsMoving ()
	{
		return m_moving;
	}
	virtual void End ();
  virtual int Keyboard (int k, int st, float x, float y);
  virtual int MouseButton (int bt, int st, float x, float y);
  virtual int MouseMotion (int bt, float x, float y);
};

#endif
