//* planenavig.h
// fabraham@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// Apr 2005

#ifndef VGL_PLANE_NAVIG_H
#define VGL_PLANE_NAVIG_H

#include <vgl/vglac.h>
#include "navig.h"

class VglViewSurface;
class VglCamera;

// TODO: enable navigation plane configuration. currently, using a=0,b=1,c=0,d=0
class VGLACAPI VglPlaneNavigHandler : public VglNavigHandler
{
  AlgVector m_translation;
  AlgVector m_eyepos;
  AlgMatrix m_view;
  VglCamera *m_camera;
protected:
  float m_mindistance;
  bool m_constraindistance;
public:
  /**
   * Internal function. not to be called.
   */
  void CalcTranslation ();
protected:
  virtual void DoNavigThrough ();
public:
  static char* CLASSNAME () { return "PlaneNavigHandler"; }
  virtual char* ClassName () const { return CLASSNAME(); }
  VglPlaneNavigHandler (VglViewSurface* surface, float maxvel=0.2f, float accel=1.0f);
  virtual ~VglPlaneNavigHandler ();
  void SetMinDistance (float d)
  {
    m_mindistance = d;
    m_constraindistance = true;
  }
  void UnsetMinDistance ()
  {
    m_constraindistance = false;
  }
};

#endif
