#ifndef VGL_POINT_PICK_H
#define VGL_POINT_PICK_H

#include <alg/vector.h>
#include <vgl/hnd/selection.h>
#include <vgl/viewsurface.h>

#define VGL_POINT_PICK_HANDLER "PointPickHandler"


class VGL_API VglPickHandler : public VglSelectionHandler
{
public:
   VglPickHandler(VglViewSurface* surface, int sel_buf_size = 512, double tolw = 5.0, double tolh = 5.0) : 
      VglSelectionHandler(surface, sel_buf_size, tolw, tolh)
      {};
      
   virtual ~VglPickHandler(){};

   static char* CLASSNAME () { return VGL_POINT_PICK_HANDLER; }
   virtual char* ClassName () const { return CLASSNAME(); }

   void GetClosestPoint(float x, float y, float *wx, float *wy, float *wz);

protected:
   double m_x, m_y, m_z;
   virtual void ProcessFunction (VglSelectionHit* hits, int n);
};

#endif