//* zoom.h
// celes@tecgraf.puc-rio.br
// Tecgraf/PUC-Rio
// Jan 2003

#ifndef VGL_ZOOM_H
#define VGL_ZOOM_H

#include <vgl/handler.h>

class VglViewSurface;

class VGL_API VglZoomHandler : public VglHandler
{
  VglViewSurface* m_surface;
  char m_constraint;
  float m_x0, m_x1, m_y0, m_y1;
  bool m_drawwindow;
  bool m_animated;
  void DrawWindow (bool, float, float, float, float);
protected:
  virtual void Zoom (float dx, float dy, float x, float y);
  virtual int UndoZoom ();
  virtual int RedoZoom ();
  virtual void TranslateZoom (float x, float y);
  virtual void ScaleZoom (float s);
public:
  /**
   * Returns the event handler class classname.
   * \return Event handler class classname.
   */
  static char* CLASSNAME () { return "ZoomHandler"; }
  virtual char* ClassName () const { return CLASSNAME(); }

  VglZoomHandler (VglViewSurface *surface);
  virtual ~VglZoomHandler ();
  void SetAnimated(bool flag);
  VglViewSurface* GetSurface ()
  {
    return m_surface;
  }
  virtual int MouseButton (int bt, int st, float x, float y);
  virtual int MouseMotion (int bt, float x, float y);
  virtual int PostRedraw ();
};

#endif
